function [bbs_norm bbs_mti speed course UTCtime ACPrange WindDir WindSpd C_map]=CNav_v10_coh_PPI_JOB(logger_fil,dop_pros,C_map)
%{
Utgangspunkt: CNav_v10_01_coh_PPI - Yngve Steinheim

Forenklet av ErL. PPar_gen og PPar_ini brukes ikke. Alle parametre er samlet i toppen av skriptet.
Denne utgaven er derfor egnet for dedikerte scenario - Vrnes/Alta.

Erik Lvli - Radian AS 15april 2014.
10juni2014 - Innfrt enkelt MTI filter, for demping av bakkeclutter, fr MTD. 
Gir bedre deteksjonsevne for JOB-Case1 selv om CACFAR terskel m heves fra 7 til 15 for  opprettholde Pfa.  

John-Olav Bratteb - NTNU
16juni2014 - Innfrt Clutter Map (CM) og CACM-CFAR som cfar method #4.
C_map er n ogs bde en inn- og utverdi i CNav, og m initialiseres
utenfor CNav. C_map m matche de range- og asimut-desimerte MTD-matrisene 
i dimensjoner/strrelse.

John-Olav Bratteb - NTNU
23okt2014 - Innfrt kode for plotting av Clutter Attenuation
%}

% Definisjon av loggerfil metadata som kallende program (PPI) krever i retur.
speed=0; course=0; UTCtime=0; ACPrange=360; WindDir=0; WindSpd=0;
%% Parametre
des_faktor = 3; % Desimeringsfaktor i range
ant_mtd_kanaler=16; fft_length = ant_mtd_kanaler;
az_grd=8; % N/2 betyr halv overlapp i asimut nr fft lengden er N
calc_precision='single';
MTI=0; %Enabler MTI pre-FFT filter (Single canceller [1 -1])
fft_window_alpha=1.1; 
NCI_win=15; % Asimut pulsintegrasjon i normal kanalen
max_video=15000; % Normal video klippeniv
max_PPI_dyn = 255; % Max video amplitude for signal ut til PPI. 

% CFAR
CFAR_meth = 5;      % CA/OS/OS_mex/CACM/OSCM = 1/2/3/4/5
CFAR_mult = 4;      % 15 med MTI. 7 uten MTI;
CM_mult = 4;        % Clutter Map threshold multiplier

CFAR_win = 8;      % N/2 , Strrelse p vinduet p hver side av CUT
CFAR_guard = 1;     % 1 for CA
    if CFAR_meth == 2 || CFAR_meth == 5 
        CFAR_guard = 0; % 0 for OS
    end
OSCFAR_rank = 12;   % Br vre (3/4)*2*CFAR_win
CM_alpha = 0.2;     % Clutter Map alpha

% Beregn og plott Clutter Attenuation?
CAplot = 0;
% Visning av landclutter i null kanalen (for CFAR_meth = 1, 2 eller 3)
CFAR_landclutt = 0; % 0/1. Enabler fast terskel for deteksjon av landclutter i null kanalen
CFAR_landclutt_lvl = 10000; % Fast terskel for deteksjon av landclutter i null kanalen
% Yngves metode for demping av dopplersidelober fra landclutter
CFAR_sidelobe_mask = 0; % Enabler maskering av sidelober fra landclutter
CFAR_near_sidelobe_lvl = 1; % Nullkanal divisor for landclutter maskering
CFAR_far_sidelobe_lvl = 7;  % Nullkanal divisor for landclutter maskering

%% Laster inn signalfil
load(logger_fil); %Loader variablene "video" og "speed" (mfl.)
%load('D:\Signalopptak\Vernes\tor10april\coh\S2_coh_260_220_1424_30298');

%% Yngves prepros av signalet
    bbs=coh_sektor; %bytter variabelnavn p matrise med radardata
    clear coh_sektor;
    bbs=conj(bbs); %Snur dreieretning p kompleks vektor slik at hastigheter blir riktig ift YS implementering
    %Beregn gjennomsnittlig PRF for sektor
        header=bbs(1:8, :); % Legger header i h
        PRF=round(1/(0.096e-6*mean(header(3,2:end)*256+header(4,2:end)))); %0.096 usec inkrement. Frste pri ikke valid".
    %Signaldata til single. Header fjernes
    bbs=single(bbs(9:end,:)); 
    
%% Desimering i range
    bbs=bbs(1:des_faktor:end,:); 
    
%% MTI filtrering av signalet fr MTD
if MTI==1
S_can=([0.707 -0.707])';     % Normalisert single MTI
bbs = (filter(S_can, 1, bbs.')).'; % MTI filtrerer
end

%% MTD med FFT filterbank (og mulighet for desimering i azimuth)
sect_ind=1:az_grd:(size(bbs,2)-fft_length+1); %array med indekser til 1. pri i hver delsektor. Bredden p hver sektor er lengden p FIR-filterene
MTD_pros=zeros(size(bbs,1),length(sect_ind),ant_mtd_kanaler,calc_precision); %preallokering
    %FFT vindu
    fft_win=repmat(gausswin(fft_length,fft_window_alpha).',size(bbs,1),1);
    % MTD-filtrering
    for m=1:length(sect_ind)
    %MTD_pros(:,m,:)=bbs(:,sect_ind(m):(sect_ind(m)+filter_length-1))*filter_koeff;
    MTD_pros(:,m,:)=fft(conj(bbs(:,sect_ind(m):(sect_ind(m)+fft_length-1))).*fft_win,fft_length,2);
    end
    
%% CA-plott kode
if CAplot
%         rseg = 70:72;
        rseg=18:20;
%         figure, imagesc(abs(bbs))
%         caxis([0 max(max(bbs))])
%         figure, imagesc(abs(MTD_pros(:,:,4)))
%         caxis([0 max(max(bbs))])
        IN=abs(bbs(rseg,sect_ind));
        OUT=abs(MTD_pros(rseg,:,4)/(10*log10(fft_length)));

        figure, 
        CA = 20*log10(mean(IN)./mean(OUT));
%       CA = 20*log10(mean(abs(MTD_pros(rseg,:,1)))./mean(abs(MTD_pros(rseg,:,4))));
        plot(CA,'b')
        CAmeandB = mean(CA)
        set(gcf,'Color','w')
        title('Normalized Clutter Attenuation (CA)','FontName','Calisto MT', 'FontSize', 16)
        xlabel('Decimated PRIs','FontName','Calisto MT', 'FontSize', 14)
        ylabel('CA [dB]','FontName','Calisto MT', 'FontSize', 14)
        axis([0 560 5 45])
        clear IN OUT rseg
end
                      
%% Deteksjon og CFAR
MTD_pros=abs(MTD_pros);
if CFAR_meth==1         %CA
    MTD_det=CA_CFAR_v1_2(MTD_pros,CFAR_win,CFAR_guard,CFAR_mult,CFAR_landclutt,CFAR_landclutt_lvl,CFAR_sidelobe_mask,CFAR_near_sidelobe_lvl,CFAR_far_sidelobe_lvl,calc_precision);
    elseif CFAR_meth==2 %OS
    MTD_det=OS_CFAR_v1_1(MTD_pros,CFAR_win,CFAR_guard,OSCFAR_rank,CFAR_mult,CFAR_landclutt,CFAR_landclutt_lvl,CFAR_sidelobe_mask,CFAR_near_sidelobe_lvl,CFAR_far_sidelobe_lvl,calc_precision);
    elseif CFAR_meth==3 %OS_mex
    MTD_det=OS_CFAR_mex_v1_2(MTD_pros,CFAR_win,CFAR_guard,OSCFAR_rank,CFAR_mult,CFAR_landclutt,CFAR_landclutt_lvl,CFAR_sidelobe_mask,CFAR_near_sidelobe_lvl,CFAR_far_sidelobe_lvl,calc_precision);
    elseif CFAR_meth==4 %CACM
    [MTD_det, C_map]=CACM_CFAR_v1(MTD_pros,CFAR_win,CFAR_guard,CFAR_mult,CM_alpha,CM_mult,calc_precision,C_map);
    elseif CFAR_meth==5 %OSCM
    [MTD_det, C_map]=OSCM_CFAR_v1(MTD_pros,CFAR_win,CFAR_guard,OSCFAR_rank,CFAR_mult,CM_alpha,CM_mult,calc_precision,C_map);
end

clear MTD_pros

%% Koding av MTD-data for presentasjon p PPI
kanalverdi=abs([1:ant_mtd_kanaler/2+1,-ant_mtd_kanaler/2:-2]);
for n=1:ant_mtd_kanaler
   MTD_det(:,:,n)=MTD_det(:,:,n)*kanalverdi(n); %Hver deteksjon gis en "kanalverdi" som er absoluttverdi av hastighet, der null er definert som "en"
end
MTD_det(MTD_det==0)=0.5; %Alle ikke-deteksjoner fr verdien 0,5
[MTD_tot, MTD_kanal]=max(MTD_det,[],3); %Finner maks hastighet for hver celle og hvilken kanal, 1-ant_kanaler, den tilhrer
clear MTD_det
MTD_tot(MTD_kanal>ant_mtd_kanaler/2+1)=MTD_tot(MTD_kanal>ant_mtd_kanaler/2+1)*(-1)+ant_mtd_kanaler/2+1; %Snur fortegn p verdi fra kanaler ant_kanaler/2+1 til ant_kanaler siden disse er fra negativ side av doppleraksen, og legger til (ant_kanaler/2+1) slik at verdiene gr fra 1 til (ant_kanaler/2-1)
MTD_tot(MTD_kanal<=(ant_mtd_kanaler/2+1))=MTD_tot(MTD_kanal<=(ant_mtd_kanaler/2+1))+(ant_mtd_kanaler/2-1); %Rejusterer verdiene slik at de gr fra ant_kanaler/2 til ant_kanaler

MTD_tot(MTD_tot==(ant_mtd_kanaler/2-0.5))=0; %Alle celler med verdi (antkanaler/2-0.5) er ikke-deteksjoner (ellers ville de hatt verdien (ant_kanaler/2-1), samme som deteksjoner i kanal ant_kanaler ("siste" MTD filter))
MTD_tot=MTD_tot.*max_PPI_dyn/ant_mtd_kanaler; %Verdi p deteksjoner tilpasses dynamikk for PPI (1:255)
                        
%% Ekspanderer detektert sektor til az_grd s mange pri'er
temp_det=MTD_tot;
MTD_tot=zeros(size(temp_det,1),size(temp_det,2)*az_grd,calc_precision);
for r=1:az_grd
   MTD_tot(:,r:az_grd:end)=temp_det;
end
clear temp_det
%% Justerer asimut bredde p bbs (uprosessert) og header
 h_sta_pri=ceil(fft_length/2)-ceil(az_grd/2)+1;
 h_stp_pri=h_sta_pri+size(MTD_tot,2)-1;
 bbs=bbs(:,h_sta_pri:h_stp_pri); 
 header=header(:,h_sta_pri:h_stp_pri);

%% Ikke-koherent integrasjon for normal video
abs_bbs = filter(ones(NCI_win,1)/((NCI_win)),1,abs(bbs'))';

%% Tilpasning til PPI, normal og MTD data
%Normal video til venstre, MTD til hyre
env_det_video_unpros=abs_bbs; 
env_det_video_pros=MTD_tot;                 

% Dynamikkbegrensning - normal. Tilpasning til PPI dynamikk
env_det_video_unpros(env_det_video_unpros>max_video)=max_video;
env_det_video_1_8bit=max_PPI_dyn*env_det_video_unpros/max_video;

%Zeropadding av MTD-data for alignment med normal video:
zpad=CFAR_win+CFAR_guard;
env_det_video_2_8bit=[zeros(zpad,size(env_det_video_pros,2));env_det_video_pros;zeros(zpad,size(env_det_video_pros,2))];                        

%Ekspanderer til des_faktor s mange range sampler
video_exp_data1=zeros(des_faktor*size(env_det_video_2_8bit,1),size(env_det_video_2_8bit,2));
video_exp_data2=video_exp_data1;

for r=1:des_faktor
video_exp_data1(r:des_faktor:end,:)=env_det_video_1_8bit;
video_exp_data2(r:des_faktor:end,:)=env_det_video_2_8bit;
end

bbs_norm=[header(1:8,:);video_exp_data1];        
bbs_mti=[header(1:8,:);video_exp_data2];

%% Konverterer til uint8 for visning i PPI
bbs_norm = uint8(bbs_norm);
bbs_mti = uint8(bbs_mti);


clearvars -except bbs_norm bbs_mti speed course UTCtime ACPrange LO_offset WindDir WindSpd C_map   