clear all
close all
T=2.333;
BA_v_max=23;
BA_a_tol=30;
runwayplacement = 370;

EW = 0; % Early Warning on/off

numberofbatches = 44;
filesperbatch = 4;

savetrackfigures = 1;
savevideo = 1;

Case = 3;

showallplots = 1;
showCTs = 1;
showBAs = 0;

ALL_Trackmatrix = [];
ALL_Plotmatrix_c = [];
ALL_MatchedTracks = [];
ALL_tentative_tracks = 0;

No_of_conf_tracks = zeros(1,numberofbatches);
No_of_tent_tracks = zeros(1,numberofbatches);

EWfigure = figure();
whitebg('w')
set(gcf,'Color','w')                % Bakgrunnsfarge i ramme
set(gcf,'Position',[400 60 900 900])
imgmap = imread('Map_background2.png');
hold on
imagesc([-5000 5000], [5000 -5000], imgmap)
axis([-4000 4000 -3000 5000])
xlabel('Easting [m]','FontName','Calisto MT', 'FontSize', 14)
ylabel('Northing [m]','FontName','Calisto MT', 'FontSize', 14)
% axis([-3000 -1000 0 2000]) % zoom over fjorden
if Case == 1
    % zoom case 1
    axis([-3500 2100 -1100 1700])
    set(gcf,'Position',[200 100 1050 500])
    filename = 'Case1 Tracks CA6 CM6 MTI0 M4 DMHC1 DMUA1 SF1'; % Case 1
elseif Case == 3
    % zoom case 3
    axis([-3200 1200 -1000 4000]) 
    set(gcf,'Position',[200 100 550 650])
    set(gca,'XTick',1000*[-3:1]) 
    set(gca,'YTick',1000*[-1:4]) 
%     filename = 'Case3 Tracks CA6 CM6 MTI0 M4 DMHC1 DMUA1 SF1'; % Case 3
%     filename = '5perBatch Case3 Tracks CA6 CM6 MTI0 M4 DMHC1 DMUA1 SF1'; % Case 3   M out of 5
    filename = '4perBatch Case3 Tracks CA8 CM8 MTI0 M3 DMHC1 DMUA1 SF1'; % Case 3   M out of 4
%     filename = '3perBatch Case3 Tracks CA8 CM8 MTI0 M2 DMHC1 DMUA1 SF1'; % Case 3   M out of 3
end
alpha(0.5)

MatchedTracks = [];

for batch = 1:numberofbatches
    BAcoord = [];
    load(['Results/' filename '/' filename ' - Batch ' num2str(batch) '.mat'])
%     assignin('base',['Trackmatrix_' num2str(batch)],Trackmatrix);
    ALL_Trackmatrix = [ALL_Trackmatrix; Trackmatrix];
    No_of_conf_tracks(batch)=size(Trackmatrix,1);
%     assignin('base',['Plotmatrix_c_' num2str(batch)],Plotmatrix_c);
    ALL_Plotmatrix_c = [ALL_Plotmatrix_c; Plotmatrix_c];
    ALL_MatchedTracks = MatchedTracks;
%     assignin('base',['tentative_tracks_' num2str(batch)],tentative_tracks);
    ALL_tentative_tracks = ALL_tentative_tracks + tentative_tracks;
    No_of_tent_tracks(batch)=tentative_tracks;
    
    for n=1:size(Trackmatrix,1)
        hold on
        plots=Trackmatrix(n,Trackmatrix(n,:)~=0);
        X=Plotmatrix_c(plots,1);
        Y=Plotmatrix_c(plots,2);
        plot(X,Y,'b')
    end
    if showallplots
        scatter(Plotmatrix_c(:,1),Plotmatrix_c(:,2),4,'k')
        alpha(0.5)
    end
    if batch ~= 1 && size(MatchedTracks,1) > 0
        for n=1:size(MatchedTracks,1)
            if MatchedTracks(n,1)==batch-1 && MatchedTracks(n,3)==batch
                [~,~,p1]=find(Prev_Trackmatrix(MatchedTracks(n,2),:),1,'last');
                x1 = Prev_Plotmatrix_c(p1,1);
                y1 = Prev_Plotmatrix_c(p1,2);
                [~,~,p2]=find(Trackmatrix(MatchedTracks(n,4),:),1,'last');
                x2 = Plotmatrix_c(p2,1);
                y2 = Plotmatrix_c(p2,2);
                if showCTs
                    line([x1 x2], [y1 y2],'LineStyle','-','LineWidth',1,'Color','b');   % plot confirmed tracks as blue lines
                end
                if showBAs
                    scatter([x1 x2],[y1 y2],100,'r','Marker','d')      % plot batch associations as red diamonds
                end
                
                % Find batch association course (0 is East, CCW increase)
                x=x2-x1;
                y=y2-y1;
                BAcourse = (180/pi)*asin(y/sqrt(x^2+y^2));
                if x<0
                    BAcourse = 180 - BAcourse;
                elseif x > 0 && y < 0
                    BAcourse = 360 - abs(BAcourse);
                end
                BAcoord = [BAcoord; x1 y1 x2 y2 BAcourse]; % Save matched track-pair coordinates
                clear x1 x2 y1 y2
            end
        end
    end
    %% Search for potential hazardous BFP situations
    if EW    
        EWplacement = [0 0];
        del = [];
        if batch ~= 1 && numel(BAcoord)>0
            for ba = 1:size(BAcoord,1)
                x1 = BAcoord(ba,1);
                y1 = BAcoord(ba,2);
                x2 = BAcoord(ba,3);
                y2 = BAcoord(ba,4);
                BAcourse = BAcoord(ba,5);
                % If course towards a crossing of the runway (at y=runwayplacement)
                if ((0 <= BAcourse) && (BAcourse <= 180) && (y2 < runwayplacement)) || ((180 <= BAcourse) && (BAcourse <= 360) && (y2 > runwayplacement)) 
                    % Search for BA in previous batch
                    if size(Prev_BAcoord,1)>0
                        for prev_ba = 1:size(Prev_BAcoord,1)
                            range_to_prev = sqrt((x1-Prev_BAcoord(prev_ba,3)^2+(y1-Prev_BAcoord(prev_ba,4))^2));
                            % If BAs are found sufficiently close with small
                            % enough deviation in course
                            if (range_to_prev < filesperbatch*T*BA_v_max) && ismember(1,abs(BAcourse-(Prev_BAcoord(prev_ba,5)+[-360 0 360])) < BA_a_tol)
                                % Place big EW marker around the most recent
                                % measurement
                                if sqrt((EWplacement(1)-x2)^2+(EWplacement(2)-y2)^2) > 100
                                        scatter(x2,y2,180,'r','Marker','s','LineWidth',1.5)
                                        EWplacement = [x2, y2];
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    %% Save figures
    if EW == 1
        folder = 'EWfigures';
    elseif showallplots == 1
        folder = 'Trackfigures.w.plots';
    else
        folder = 'Trackfigures';
    end
    if savetrackfigures %&& ismember(batch,1:24)
        set(gcf,'PaperPositionMode','auto');
        saveas(EWfigure, [folder,'/', filename, ' - Batch ', num2str(batch),'.png'], 'png')
    end
    %% Prepare for next batch
    Prev_Trackmatrix = Trackmatrix;
    Prev_Plotmatrix_c = Plotmatrix_c;
    Prev_BAcoord = BAcoord;
    pause(0.4)
end

%% Create video
if savevideo
    disp('Creating .mp4 video...')  %#ok
    % Construct a VideoWriter object
    outputVideo = VideoWriter(fullfile(folder, [filename '.mp4']),'MPEG-4'); 
    outputVideo.FrameRate = 1;
    open(outputVideo);
    % Loop through the image sequence, load each image and write it to the video.
    for i = 1:numberofbatches
        imfilename = fullfile(folder,[filename,' - Batch ', num2str(i) '.png']);
        img = imread(imfilename);
        writeVideo(outputVideo,img);
    end
    % Finalize the video file.
    close(outputVideo);
    
    disp('Creating .avi video...')
    % Construct a VideoWriter object
    outputVideo = VideoWriter(fullfile(folder, [filename '.avi'])); 
    outputVideo.FrameRate = 1;
    open(outputVideo);
    % Loop through the image sequence, load each image and write it to the video.
    for i = 1:numberofbatches
        imfilename = fullfile(folder,[filename,' - Batch ', num2str(i) '.png']);
        img = imread(imfilename);
        writeVideo(outputVideo,img);
    end
    % Finalize the video file.
    close(outputVideo);
    disp('Finished!')
end
clear filesperbatch numberofbatches Trackmatrix Plotmatrix Plotmatrix_c batch s svar v vr vrd vrdvar vvar tentative_tracks